﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;



namespace GraphSD
{
    
    public partial class Form1 : Form
    {
        GraphPartitioningProblemSD mProblem;
        int NumSup;
        int NumDem;
        public Form1()
        {
            InitializeComponent();
            Initialize();
            NumSup  = 8;
            NumDem  = 4;

        }

        public void Initialize() {

            mProblem = new GraphPartitioningProblemSD();
            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();
            mProblem.Visualiser.SetScreen(formGraphics2);
        
        }

        private void buttonTest_Click(object sender, EventArgs e)
            
        {
            mProblem.StartCalculation();
            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();
            mProblem.Visualiser.SetScreen(formGraphics2);
            mProblem.Visualiser.DrawTest();

            propertyGridProblem.SelectedObject = mProblem;
        }

        private void buttonStep_Click(object sender, EventArgs e)
        {
            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();

          
            mProblem.Visualiser.SetScreen(formGraphics2);
           mProblem.GreedyCalcPartioning(-1);
            mProblem.Visualiser.DrawTest();

            mProblem.Visualiser.SaveImageOfGraph("Test.jpg");
            propertyGridProblem.Refresh();
        }
        public void DataSets(out int[] aNumSupply, out int[] aDemandMult)
        {


            int index = 0;


             aNumSupply = new int[NumSup];
             aDemandMult = new int[NumDem];
         

            index = 0;
            aNumSupply[index++] = 2;
            aNumSupply[index++] = 5;
            aNumSupply[index++] = 10;
            aNumSupply[index++] = 25;
            aNumSupply[index++] = 50;
            aNumSupply[index++] = 100;
           aNumSupply[index++] = 200;
           aNumSupply[index++] = 400;

            index = 0;
            aDemandMult[index++] = 3;
            aDemandMult[index++] = 5;
            aDemandMult[index++] = 10;
            aDemandMult[index++] = 20;
        
        }

        public void TestHeuristics(string Folder) {

            int nNumSupply;
            int nNumDemmand;

            int nNumEdges;
            int nMaxWeight = 18;
            float nCovered = (float)0.95;
            int[] aNumSupply;
            int[] aDemandMult;

            //      int nRandomSeed = 1;

           
             DataSets(out aNumSupply, out  aDemandMult);

            List<int>[] Solutions = new List<int>[3];
            List<int>[] Opt = new List<int>[3];




            List<double> ErrorPrecent = new List<double>();
            /*  
              double AvgError;
              double MaxError;
              double MinError;
              int NumberOfProblems;
              */

            int[] MinIns = new int[40];
            int[] IsOpt = new int[3];
            double[] Avg = new double[3];
            int[] Best = new int[3];
            double AvgOpt;


            int MaxOpt, MaxBest;
            double MinAvg;
            String tString;
            String sString;

            double[] AvgErrorP = new double[3];
            double[] MaxErrorP = new double[3];
            double[] StdevP = new double[3];

            double MinAvgErrorP;
            double MinMaxErrorP;


            System.IO.StreamWriter fileStat = new System.IO.StreamWriter(Folder+"ResultsStat.txt");
            fileStat.Close();

            GraphPartitioningProblemSD[] Problem = new GraphPartitioningProblemSD[3];

            for (int i = 0; i < 3; i++)
            {

                Problem[i] = new GraphPartitioningProblemSD();
                Problem[i].UseCorrection = RCorrectionType.None;
                Problem[i].UseMultiHeuristic = false;
                Problem[i].HeuristicNode = RNodeHeuristicType.MaxDemand;
 //general
 //               Problem[i].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
                //tree
 //               Problem[i].HeuristicSubgraph = RSubGraphHeuristicType.BalanceSupNeigh;

            }


           Problem[0].HeuristicSubgraph = RSubGraphHeuristicType.MaxSupply;
            Problem[1].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
            Problem[2].HeuristicSubgraph = RSubGraphHeuristicType.BalanceSupNeigh;


        //    Problem[0].HeuristicNode = RNodeHeuristicType.MaxDemand;
        //   Problem[1].HeuristicNode = RNodeHeuristicType.MaxNeighbors;
        //   Problem[2].HeuristicNode = RNodeHeuristicType.BalanceDemNeigh;


            int numOpt;
            for (int i = 0; i < NumSup; i++)
            {
                for (int j = 0; j < NumDem; j++)
                {

                    nNumSupply = aNumSupply[i];
                    nNumDemmand = nNumSupply * aDemandMult[j];


                    MinAvg = double.MaxValue;
                    MaxOpt = 1;
                    MinAvgErrorP = double.MaxValue;
                    MinMaxErrorP = double.MaxValue;



                    ////////////////////////////////////////
                    for (int k = 0; k < 3; k++)
                    {
                        Problem[k].SolveProblemSet(nNumSupply, nNumDemmand, out Solutions[k], out Opt[k], Folder);
                        Avg[k] = Solutions[k].Average();
                        numOpt = 0;

                        GetStats(Solutions[k], Opt[k], out AvgErrorP[k], out MaxErrorP[k], out StdevP[k]);


                        IsOpt[k] = numOpt;


                        if (AvgErrorP[k] < MinAvgErrorP)
                            MinAvgErrorP = AvgErrorP[k];

                        if (MaxErrorP[k] < MinMaxErrorP)
                            MinMaxErrorP = MaxErrorP[k];


                        if (Avg[k] < MinAvg)
                            MinAvg = Avg[k];


                    }


                    ///////////////////////////
                    //      Print
                    ///////////////////////////


                    tString = nNumSupply + " X " + nNumDemmand + " & ";
                    sString = nNumSupply + " X " + nNumDemmand + " & ";

                    for (int k = 0; k < 3; k++)
                    {


                        ////   STAT

                        if (AvgErrorP[k] == MinAvgErrorP)
                            sString += "\\underline{" + Math.Abs(AvgErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(AvgErrorP[k]).ToString("0.0") + " & ";

                        if (MaxErrorP[k] == MinMaxErrorP)
                            sString += "\\underline{" + Math.Abs(MaxErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(MaxErrorP[k]).ToString("0.0") + " & ";

                        sString += StdevP[k].ToString("0.0");

                        if (k < 2)
                            sString += " & ";



                    }

                    sString += " \\\\";

                    tString += Opt[0].Average().ToString("0.0") + " \\\\";

                    fileStat = new System.IO.StreamWriter(Folder + "ResultsStat.txt", true);
                    fileStat.WriteLine(sString);
                    fileStat.Close();
                }
                fileStat = new System.IO.StreamWriter(Folder + "ResultsStat.txt", true);
                fileStat.WriteLine("\\midrule");
                fileStat.Close();
            

            }
            
        }


        public void TestCorrection(string Folder)
        {

            int nNumSupply;
            int nNumDemmand;

            int nNumEdges;
            int nMaxWeight = 18;
            float nCovered = (float)0.95;
            int[] aNumSupply;
            int[] aDemandMult;

            //      int nRandomSeed = 1;


            DataSets(out aNumSupply, out  aDemandMult);

            List<int>[] Solutions = new List<int>[4];
            List<int>[] Opt = new List<int>[4];




            List<double> ErrorPrecent = new List<double>();
            /*  
              double AvgError;
              double MaxError;
              double MinError;
              int NumberOfProblems;
              */

            int[] MinIns = new int[40];
            int[] IsOpt = new int[4];
            double[] Avg = new double[4];
            int[] Best = new int[4];
            double AvgOpt;


            int MaxOpt, MaxBest;
            double MinAvg;
            String tString;
            String sString;

            double[] AvgErrorP = new double[4];
            double[] MaxErrorP = new double[4];
            double[] StdevP = new double[4];
            double[] cTime = new double[4];

            double MinAvgErrorP;
            double MinMaxErrorP;


            System.IO.StreamWriter fileStat = new System.IO.StreamWriter(Folder + "ResultsStatCor.txt", false);
            fileStat.Close();

            GraphPartitioningProblemSD[] Problem = new GraphPartitioningProblemSD[4];

            for (int i = 0; i < 4; i++)
            {
                Problem[i] = new GraphPartitioningProblemSD();
                Problem[i].UseCorrection = RCorrectionType.None;
                Problem[i].UseMultiHeuristic = false;
//                Problem[i].HeuristicNode = RNodeHeuristicType.MaxDemand;
                //general
//                Problem[i].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
                //tree
                Problem[i].HeuristicSubgraph = RSubGraphHeuristicType.BalanceSupNeigh;
                Problem[i].HeuristicNode = RNodeHeuristicType.BalanceDemNeigh;

            }




            Problem[1].UseCorrection     = RCorrectionType.Basic;
            Problem[2].UseCorrection     = RCorrectionType.Complete;

            Problem[3].UseCorrection     = RCorrectionType.Complete;
            Problem[3].UseMultiHeuristic = true;


            int numOpt;
            for (int i = 0; i < NumSup; i++){
                for (int j = 0; j < NumDem; j++)
                {

                    nNumSupply = aNumSupply[i];
                    nNumDemmand = nNumSupply * aDemandMult[j];


                    MinAvg = double.MaxValue;
                    MaxOpt = 1;
                    MinAvgErrorP = double.MaxValue;
                    MinMaxErrorP = double.MaxValue;



                    ////////////////////////////////////////
                    for (int k = 0; k < 4; k++)
                    {
                        Problem[k].SolveProblemSet(nNumSupply, nNumDemmand, out Solutions[k], out Opt[k], Folder);
                        Avg[k] = Solutions[k].Average();
                        cTime[k] = Problem[k].CalcTime/(float)1000;
                        numOpt = 0;

                        GetStats(Solutions[k], Opt[k], out AvgErrorP[k], out MaxErrorP[k], out StdevP[k]);


                        IsOpt[k] = numOpt;


                        if (AvgErrorP[k] < MinAvgErrorP)
                            MinAvgErrorP = AvgErrorP[k];

                        if (MaxErrorP[k] < MinMaxErrorP)
                            MinMaxErrorP = MaxErrorP[k];


                        if (Avg[k] < MinAvg)
                            MinAvg = Avg[k];


                    }


                    ///////////////////////////
                    //      Print
                    ///////////////////////////


                    tString = nNumSupply + " X " + nNumDemmand + " & ";
                    sString = nNumSupply + " X " + nNumDemmand + " & ";
                    /*
                    for (int k = 0; k < 4; k++)
                    {


                        ////   STAT

//                        if (AvgErrorP[k] == MinAvgErrorP)
//                            sString += "\\underline{" + Math.Abs(AvgErrorP[k]).ToString("0.0") + "} & ";
//                        else
                            sString += Math.Abs(AvgErrorP[k]).ToString("0.0") + " & ";
//                        if (MaxErrorP[k] == MinMaxErrorP)
 //                           sString += "\\underline{" + Math.Abs(MaxErrorP[k]).ToString("0.0") + "} & ";
 //                       else
                            sString += Math.Abs(MaxErrorP[k]).ToString("0.0") + " & ";

                        sString += cTime[k].ToString("0.0");

                        if (k < 3)
                            sString += " & ";



                    }
                    */

                    for (int k = 0; k < 4; k++)
                        sString += Math.Abs(AvgErrorP[k]).ToString("0.0") + " & ";
                    for (int k = 0; k < 4; k++)
                        sString += Math.Abs(MaxErrorP[k]).ToString("0.0") + " & ";
                    for (int k = 0; k < 4; k++)
                    {
                        sString += cTime[k].ToString("0.0");
                        if (k < 3)
                            sString += " & ";

                    }

                    
                    sString += " \\\\";

                    tString += Opt[0].Average().ToString("0.0") + " \\\\";

                    fileStat = new System.IO.StreamWriter(Folder + "ResultsStatCor.txt", true);
                    fileStat.WriteLine(sString);
                    fileStat.Close();
                }
                fileStat = new System.IO.StreamWriter(Folder + "ResultsStatCor.txt", true);
                fileStat.WriteLine("\\midrule");
                fileStat.Close();
            

            }


        }
        private void buttonSolveAll_Click(object sender, EventArgs e)
        {


   //         TestHeuristics(".\\Tree\\");
            TestHeuristics(".\\General\\");


     //      TestCorrection(".\\Tree\\");
       //     TestCorrection(".\\General\\");


            /*
            int[] aNumSupply = new int[8];
            int[] aDemandMult = new int[3];
            int nNumSupply;
            int nNumDemmand;

            int nNumEdges;
            int nMaxWeight = 18;
            float nCovered = (float)0.95;
            //      int nRandomSeed = 1;

            int index = 0;


            index = 0;
            aNumSupply[index++] = 3;
            aNumSupply[index++] = 5;
            aNumSupply[index++] = 10;
            aNumSupply[index++] = 25;
            aNumSupply[index++] = 50;
            aNumSupply[index++] = 100;
            aNumSupply[index++] = 200;

            index = 0;
            aDemandMult[index++] = 3;
            aDemandMult[index++] = 5;
            aDemandMult[index++] = 10;

            List<int>[] Solutions = new List<int>[3];
            List<int>[] Opt= new List<int>[3];


            

            List<double> ErrorPrecent = new List<double>();
          /*  
            double AvgError;
            double MaxError;
            double MinError;
            int NumberOfProblems;
            */

/*            int[]       MinIns    = new int[40];
            int[]       IsOpt  = new int[3];
            double[]    Avg     = new double[3];
            int[]       Best    = new int[3];
            double      AvgOpt;


            int MaxOpt, MaxBest;
            double MinAvg;
            String tString;
            String sString;

            double[] AvgErrorP= new double[3];
            double[] MaxErrorP= new double[3];
            double[] StdevP = new double[3];

            double MinAvgErrorP;
            double MinMaxErrorP;
           

            System.IO.StreamWriter file = new System.IO.StreamWriter("Results.txt");
            System.IO.StreamWriter fileStat = new System.IO.StreamWriter("ResultsStat.txt");
            
            GraphPartitioningProblemSD[] Problem = new GraphPartitioningProblemSD[3];

            for (int i = 0; i < 3; i++)
            {
                
                Problem[i] = new GraphPartitioningProblemSD();
//             Problem[i].UseCorrection = true;
                Problem[i].UseCorrection = RCorrectionType.Basic;
                Problem[i].UseMultiHeuristic = true;

                if (i == 0) { 
//                 Problem[i].UseMultiHeuristic = true;
//                 Problem[i].UseMultiHeuristic = false;
                 Problem[i].UseCorrection = RCorrectionType.Complete;
                }

            }

            Problem[2].UseCorrection = RCorrectionType.None;

                //tProblem.SolveProblemSet(25, 75, out Solutions, out Opt);

                Problem[0].HeuristicSubgraph = RSubGraphHeuristicType.MaxSupply;
                Problem[1].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
                Problem[2].HeuristicSubgraph = RSubGraphHeuristicType.BalanceSupNeigh;


                Problem[0].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
                Problem[1].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
                Problem[2].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
    

                int numOpt;
            for (int i = 0; i <7; i++)
                for (int j = 0; j < 3; j++)
                {

                    nNumSupply = aNumSupply[i];
                    nNumDemmand = nNumSupply * aDemandMult[j];
                //    nNumEdges = (int)(Math.Round((double)nNumSupply + nNumDemmand * 1.5));



                    MinAvg = double.MaxValue;
                    MaxOpt = 1;
                    MinAvgErrorP = double.MaxValue;
                    MinMaxErrorP = double.MaxValue;
           

                    for (int m = 0; m < 40; m++)
                    {
                        MinIns[m] = 0;
                    }

                    ////////////////////////////////////////
                    for (int k = 0; k < 3; k++)
                    {
                        Problem[k].SolveProblemSet(nNumSupply, nNumDemmand, out Solutions[k], out Opt[k]);
                        Avg[k] = Solutions[k].Average();
                        numOpt=0;

                        GetStats(Solutions[k], Opt[k], out AvgErrorP[k], out MaxErrorP[k], out StdevP[k]);

                        for (int m = 0; m < 40; m++) {
                            if (Solutions[k][m] < MinIns[m])
                                MinIns[m] = Solutions[k][m];

                            if (Solutions[k][m] + Opt[k][m] == 0)
                                numOpt++;
                        }

                        IsOpt[k] = numOpt;


                        if (AvgErrorP[k] < MinAvgErrorP)
                        {
                            MinAvgErrorP = AvgErrorP[k];
                        }

                        if (MaxErrorP[k] < MinMaxErrorP)
                        {
                            MinMaxErrorP = MaxErrorP[k];
                        }


                        if (Avg[k] < MinAvg)
                        {
                            MinAvg = Avg[k];
                        }

                        if (IsOpt[k] > MaxOpt)
                        {
                            MaxOpt = IsOpt[k];
                        }
                    

                    }

                    MaxBest = 0;
                    for (int k = 0; k < 3; k++)
                    {
                        Best[k] = 0;
                        for (int m = 0; m < 40; m++)
                        {
                            if (Solutions[k][m] == MinIns[m])
                                Best[k]++;
                        }

                        if (MaxBest < Best[k])
                            MaxBest = Best[k];
                    }

                    ///////////////////////////
                    //      Print
                    ///////////////////////////
                   
                   
                    tString = nNumSupply + " X " + nNumDemmand + " & ";
                    sString = nNumSupply + " X " + nNumDemmand + " & ";
                 
                    for (int k = 0; k < 3; k++) {

                        if(Avg[k] == MinAvg)
                             tString += "\\underline{" + Math.Abs(Avg[k]).ToString("0.0") + "} & ";
                        else
                            tString += Math.Abs(Avg[k]).ToString("0.0") + " & ";

                        if (IsOpt[k] == MaxOpt)
                            tString += "\\underline{" + IsOpt[k] + "} & ";
                        else
                            tString += IsOpt[k] + " & ";

                        if (Best[k] == MaxBest)
                            tString += "\\underline{" + Best[k] + "} &";
                        else
                            tString += Best[k] + " &";
                  
           
          ////   STAT

                        if (AvgErrorP[k] == MinAvgErrorP)
                            sString += "\\underline{" + Math.Abs(AvgErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(AvgErrorP[k]).ToString("0.0") + " & ";

                        if (MaxErrorP[k] == MinMaxErrorP)
                            sString += "\\underline{" + Math.Abs(MaxErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(MaxErrorP[k]).ToString("0.0") + " & ";

                        sString += StdevP[k].ToString("0.0");

                        if(k<2)
                            sString += " & ";


                  
                      }

                    sString +=  " \\\\";

                    tString += Opt[0].Average().ToString("0.0") + " \\\\";

                    file.WriteLine(tString);
                    fileStat.WriteLine(sString);
            
                }

            file.Close();
            fileStat.Close();
           */
        }


        public void Old() {

            int[] aNumSupply = new int[8];
            int[] aDemandMult = new int[3];
            int nNumSupply;
            int nNumDemmand;

            int nNumEdges;
            int nMaxWeight = 18;
            float nCovered = (float)0.95;
            //      int nRandomSeed = 1;

            int index = 0;
            string Folder = ".\\";

            index = 0;
            aNumSupply[index++] = 3;
            aNumSupply[index++] = 5;
            aNumSupply[index++] = 10;
            aNumSupply[index++] = 25;
            aNumSupply[index++] = 50;
            aNumSupply[index++] = 100;
            aNumSupply[index++] = 200;

            index = 0;
            aDemandMult[index++] = 3;
            aDemandMult[index++] = 5;
            aDemandMult[index++] = 10;

            List<int>[] Solutions = new List<int>[3];
            List<int>[] Opt = new List<int>[3];




            List<double> ErrorPrecent = new List<double>();
            /*  
              double AvgError;
              double MaxError;
              double MinError;
              int NumberOfProblems;
              */

            int[] MinIns = new int[40];
            int[] IsOpt = new int[3];
            double[] Avg = new double[3];
            int[] Best = new int[3];
            double AvgOpt;


            int MaxOpt, MaxBest;
            double MinAvg;
            String tString;
            String sString;

            double[] AvgErrorP = new double[3];
            double[] MaxErrorP = new double[3];
            double[] StdevP = new double[3];

            double MinAvgErrorP;
            double MinMaxErrorP;


            System.IO.StreamWriter file = new System.IO.StreamWriter("Results.txt");
            System.IO.StreamWriter fileStat = new System.IO.StreamWriter("ResultsStat.txt");

            GraphPartitioningProblemSD[] Problem = new GraphPartitioningProblemSD[3];

            for (int i = 0; i < 3; i++)
            {

                Problem[i] = new GraphPartitioningProblemSD();
                //             Problem[i].UseCorrection = true;
                Problem[i].UseCorrection = RCorrectionType.Basic;
                Problem[i].UseMultiHeuristic = true;

                if (i == 0)
                {
                    //                 Problem[i].UseMultiHeuristic = true;
                    //                 Problem[i].UseMultiHeuristic = false;
                    Problem[i].UseCorrection = RCorrectionType.Complete;
                }

            }

            Problem[2].UseCorrection = RCorrectionType.None;

            //tProblem.SolveProblemSet(25, 75, out Solutions, out Opt);

            Problem[0].HeuristicSubgraph = RSubGraphHeuristicType.MaxSupply;
            Problem[1].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
            Problem[2].HeuristicSubgraph = RSubGraphHeuristicType.BalanceSupNeigh;


            Problem[0].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
            Problem[1].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;
            Problem[2].HeuristicSubgraph = RSubGraphHeuristicType.MinNeighbors;


            int numOpt;
            for (int i = 0; i < 7; i++)
                for (int j = 0; j < 3; j++)
                {

                    nNumSupply = aNumSupply[i];
                    nNumDemmand = nNumSupply * aDemandMult[j];
                    //    nNumEdges = (int)(Math.Round((double)nNumSupply + nNumDemmand * 1.5));



                    MinAvg = double.MaxValue;
                    MaxOpt = 1;
                    MinAvgErrorP = double.MaxValue;
                    MinMaxErrorP = double.MaxValue;


                    for (int m = 0; m < 40; m++)
                    {
                        MinIns[m] = 0;
                    }

                    ////////////////////////////////////////
                    for (int k = 0; k < 3; k++)
                    {
                        Problem[k].SolveProblemSet(nNumSupply, nNumDemmand, out Solutions[k], out Opt[k], Folder);
                        Avg[k] = Solutions[k].Average();
                        numOpt = 0;

                        GetStats(Solutions[k], Opt[k], out AvgErrorP[k], out MaxErrorP[k], out StdevP[k]);

                        for (int m = 0; m < 40; m++)
                        {
                            if (Solutions[k][m] < MinIns[m])
                                MinIns[m] = Solutions[k][m];

                            if (Solutions[k][m] + Opt[k][m] == 0)
                                numOpt++;
                        }

                        IsOpt[k] = numOpt;


                        if (AvgErrorP[k] < MinAvgErrorP)
                        {
                            MinAvgErrorP = AvgErrorP[k];
                        }

                        if (MaxErrorP[k] < MinMaxErrorP)
                        {
                            MinMaxErrorP = MaxErrorP[k];
                        }


                        if (Avg[k] < MinAvg)
                        {
                            MinAvg = Avg[k];
                        }

                        if (IsOpt[k] > MaxOpt)
                        {
                            MaxOpt = IsOpt[k];
                        }


                    }

                    MaxBest = 0;
                    for (int k = 0; k < 3; k++)
                    {
                        Best[k] = 0;
                        for (int m = 0; m < 40; m++)
                        {
                            if (Solutions[k][m] == MinIns[m])
                                Best[k]++;
                        }

                        if (MaxBest < Best[k])
                            MaxBest = Best[k];
                    }

                    ///////////////////////////
                    //      Print
                    ///////////////////////////


                    tString = nNumSupply + " X " + nNumDemmand + " & ";
                    sString = nNumSupply + " X " + nNumDemmand + " & ";

                    for (int k = 0; k < 3; k++)
                    {

                        if (Avg[k] == MinAvg)
                            tString += "\\underline{" + Math.Abs(Avg[k]).ToString("0.0") + "} & ";
                        else
                            tString += Math.Abs(Avg[k]).ToString("0.0") + " & ";

                        if (IsOpt[k] == MaxOpt)
                            tString += "\\underline{" + IsOpt[k] + "} & ";
                        else
                            tString += IsOpt[k] + " & ";

                        if (Best[k] == MaxBest)
                            tString += "\\underline{" + Best[k] + "} &";
                        else
                            tString += Best[k] + " &";


                        ////   STAT

                        if (AvgErrorP[k] == MinAvgErrorP)
                            sString += "\\underline{" + Math.Abs(AvgErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(AvgErrorP[k]).ToString("0.0") + " & ";

                        if (MaxErrorP[k] == MinMaxErrorP)
                            sString += "\\underline{" + Math.Abs(MaxErrorP[k]).ToString("0.0") + "} & ";
                        else
                            sString += Math.Abs(MaxErrorP[k]).ToString("0.0") + " & ";

                        sString += StdevP[k].ToString("0.0");

                        if (k < 2)
                            sString += " & ";



                    }

                    sString += " \\\\";

                    tString += Opt[0].Average().ToString("0.0") + " \\\\";

                    file.WriteLine(tString);
                    fileStat.WriteLine(sString);

                }

            file.Close();
            fileStat.Close();
           
        }


        public void GetStats(List<int> Solutions, List<int> Opt, out double AvgError, out double MaxError, out double Stdev) {


            List<double> ErrorPrecent = new List<double>();
           
            int NumberOfProblems = Solutions.Count;
            for (int i = 0; i < Solutions.Count; i++)
            {

                ErrorPrecent.Add(100 * (Opt[i] + Solutions[i]) / (double)Opt[i]);
            }
            
            Stdev = 0;

            AvgError = ErrorPrecent.Average();
            MaxError = ErrorPrecent.Max();

            for (int i = 0; i < Solutions.Count; i++)
            {

                Stdev += (ErrorPrecent[i] - AvgError) * (ErrorPrecent[i] - AvgError);
            }
            Stdev = Math.Sqrt(Stdev / NumberOfProblems);

        
        }

        private void buttonSolveSet_Click(object sender, EventArgs e)
        {
            List<int> Solutions;
            List<int> Opt;
            List<double> ErrorPrecent = new List<double>();
            double AvgError;
            double MaxError;
            double MinError;
            int NumberOfProblems;
            string Folder = ".\\";
            GraphPartitioningProblemSD tProblem = new GraphPartitioningProblemSD();

            tProblem.UseCorrection = RCorrectionType.Complete;
       //     tProblem.UseCorrection = false;

            tProblem.UseMultiHeuristic = true;
           tProblem.UseMultiHeuristic = false;

            tProblem.SolveProblemSet(50,500, out Solutions, out Opt,  Folder);

            NumberOfProblems = Solutions.Count;
            for (int i = 0; i < Solutions.Count; i++)
            {

                ErrorPrecent.Add(100 * (Opt[i] + Solutions[i]) / (double)Opt[i]);
            }
            double Stdev = 0;

            AvgError = ErrorPrecent.Average();
            MaxError = ErrorPrecent.Max();

            for (int i = 0; i < Solutions.Count; i++)
            {

                Stdev += (ErrorPrecent[i] - AvgError) * (ErrorPrecent[i] - AvgError);
            }

            Stdev = Math.Sqrt(Stdev / NumberOfProblems);

            GetStats(Solutions, Opt, out AvgError, out MaxError, out Stdev);
        }

        private void buttonCorrect_Click(object sender, EventArgs e)
        {

            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();


            mProblem.Visualiser.SetScreen(formGraphics2);
//            mProblem.GreedyCalcPartioning(1);

            mProblem.GreedyCalcCorrectionBasic(100);

            mProblem.Visualiser.DrawTest();

            propertyGridProblem.Refresh();

        }

        private void button1_Click(object sender, EventArgs e)
        {

            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();


            mProblem.Visualiser.SetScreen(formGraphics2);
            //            mProblem.GreedyCalcPartioning(1);

            mProblem.GreedyCalcCorrectionAdvance(100);

            mProblem.Visualiser.DrawTest();

            propertyGridProblem.Refresh();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            System.Drawing.Graphics formGraphics2 = pictureProblem.CreateGraphics();


            mProblem.Visualiser.SetScreen(formGraphics2);
            //            mProblem.GreedyCalcPartioning(1);

            mProblem.GreedyCalcCorrectionComplete(100);

            mProblem.Visualiser.DrawTest();

            propertyGridProblem.Refresh();
        }

            
        
    }
}
