﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GraphSD
{
    public class RGraphAbstract
    {
        protected int mNumberOfVertices;
        protected int mNumberOfEdges;

      //  protected bool[,] mEdges;

        protected List<int>[] mEdges1;

        protected Random mGenerator;



        public void SetGenerator(Random nGenerator) {

            mGenerator = nGenerator;
        }
        public RGraphAbstract()
        {

            mNumberOfVertices = 5;
            Init();

        }
        
        public RGraphAbstract(int nNumberOfVertices) {

            mNumberOfVertices = nNumberOfVertices;
            Init();
        
        }
        public int NumberOfVertices {
            get { return mNumberOfVertices; }
            set { mNumberOfVertices = value; }
        } 
        public void Init() {

         //   mEdges = new bool[mNumberOfVertices, mNumberOfVertices];
            mEdges1 = new List<int>[mNumberOfVertices];

            for (int i = 0; i < mNumberOfVertices; i++)
                mEdges1[i] = new List<int>();
        }

        public bool EdgeExists(int i, int j) {
         //   return mEdges[i, j];
            return mEdges1[i].Contains(j);
        }

        public List<int> GetConnections(int Index) {

            /*List<int> Result = new List<int>();

            for (int i = 0; i < mNumberOfVertices; i++) {
                    if (mEdges[Index, i] || mEdges[i, Index])
                        Result.Add(i);
            }
              return Result;
            */

            return mEdges1[Index];

                
        }
        public void RemoveConnections(int Index) {
            /*
            for (int i = 0; i < mNumberOfVertices; i++)
            {
                mEdges[Index, i]  = false;
                mEdges[i, Index]  = false;
                
            }
            */

            foreach (int c in mEdges1[Index]) {
                mEdges1[c].Remove(Index);
            }
            mEdges1[Index].Clear();


        }

        public void Copy(RGraphAbstract nGraph) {
            mNumberOfVertices = nGraph.mNumberOfVertices;
            mNumberOfEdges = nGraph.mNumberOfEdges;

            Init();
            /*
            for (int i = 0; i < mNumberOfVertices; i++)
                for (int j = 0; j < mNumberOfVertices; j++)
                    mEdges[i, j] = nGraph.mEdges[i, j];
            */

            for (int i = 0; i < mNumberOfVertices; i++) {

                foreach (int el in nGraph.mEdges1[i]) {
                    mEdges1[i].Add(el);
                }
            }
                
        }
    }
}
