﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Text.RegularExpressions;



namespace GraphSD
{
    public class RGraphSD:  RGraphAbstract
    {

        // mNumberofSupply + mNumberOfSupply = mNumberOfVertex
        int mNumberSupply;
        int mNumberDemmand;
        // Supply>0
        // Demand <0
        // 0..mNumberofSupply-1  Supply
        // mNumberofSupply..mNumberofVertices  Demand
        int[] mWeights;


        public RGraphSD()
            : base()
        {

            mNumberDemmand = 4;
            mNumberSupply = 1;
            mWeights = new int[mNumberOfVertices];


        }

        public int GetTotalSupply() {
            int Sum = 0;

            for (int i = 0; i < mNumberOfVertices; i++)
                if (mWeights[i] > 0)
                    Sum += mWeights[i];

            return Sum;
        }
        public bool HasEdge() {

            for (int i = 0; i < mNumberOfVertices; i++) {

                if (mEdges1[i].Count > 0)
                    return true;
            }

            return false;
            /*
            for (int i = 0; i < mNumberOfVertices; i++)
                for (int j = i; j < mNumberOfVertices; j++)
                    if (mEdges[i, j])
                        return true;

            return false;
       */
                }
        public void SaveGraph(System.IO.StreamWriter File) {

            String tString;

            File.WriteLine("Number of Supply");
            File.WriteLine(mNumberSupply);
            File.WriteLine("Number of Demmand");
            File.WriteLine(mNumberDemmand);
            File.WriteLine("Weights");

            for (int i = 0; i < mNumberOfVertices; i++) {
                File.WriteLine(mWeights[i]);
            }
            File.WriteLine("Edges");
            int counter;
            for (int i = 0; i < mNumberOfVertices; i++)
            {
                tString = "Edge" + Convert.ToString(i);
                File.WriteLine(tString);
                counter = 0;

                for (int j = 0; j < mNumberOfVertices; j++)
                {
                    
//                    if(mEdges[i,j]){
                    if(EdgeExists(i,j)){
                        

                            tString = Convert.ToString(j);

                            if (counter > 0)
                                tString = " " + tString;
                            counter++;
                        File.Write(tString);
                    }
                }
                File.Write("\r\n");
            }
           

      
        }


        public void LoadGraph(String FileName)
        {

            System.IO.StreamReader File = new System.IO.StreamReader(FileName);

            LoadGraph(File);

            File.Close();
        }

        public void ClearEdges() {

            /*
            for (int i = 0; i < mNumberOfVertices; i++)
                for (int j = 0; j < mNumberOfVertices; j++)
                    mEdges[i, j] = false;
            */

            for (int i = 0; i < mNumberOfVertices; i++)
                mEdges1[i].Clear();
            

        }
        public void LoadGraph(System.IO.StreamReader File)
        {

            String    tString;
            char[]    whitespace = new char[] { ' ', '\n', '\t', '\r', '\f', '\v' };
             int      CurrentBlock;
             string[] LineElements;
             int      index;
             
            tString = File.ReadLine();
            tString = File.ReadLine();
            mNumberSupply = Convert.ToInt32(tString);

            tString = File.ReadLine();
            tString = File.ReadLine();
            mNumberDemmand = Convert.ToInt32(tString);

            mNumberOfVertices = mNumberDemmand + mNumberSupply;

            Init();
            // Loading all weights
            tString = File.ReadLine();
            
            for (int i = 0; i < mNumberOfVertices; i++)
            {
                tString =File.ReadLine();
                mWeights[i] = Convert.ToInt32(tString);
            }

            //
            //          Loading edges
            //
            tString = File.ReadLine();
            bool isNumeric;

            ClearEdges();
            for (int i = 0; i < mNumberOfVertices; i++)
            {
                tString = File.ReadLine();
                tString = File.ReadLine();

              
                LineElements = Regex.Split(tString, " |\t");
               


                for (int j = 0; j < LineElements.Length; j++) {

                    
                    isNumeric = int.TryParse(LineElements[j], out index);

                    if(isNumeric)                    AddEdge(i, index);
                }
                
            }

 
        }


        public void SaveGraph(string FileName, bool Append = false)
        {
            System.IO.StreamWriter file = new System.IO.StreamWriter(FileName);
            SaveGraph(file);
            file.Close();

        }


        public void CopyWeights(RGraphSD A){
            for (int i = 0; i < NumberOfVertices; i++)
                mWeights[i] = A.mWeights[i];
        
        }
        public void Correct(RPartitioningGraphSD nPartitionig) {

            RSubGraphSD Temp;

            for (int i = 0; i < nPartitionig.NumberOfSubGraphs; i++) {

                Temp = nPartitionig.GetSubGraph(i);

                mWeights[Temp.SupplyNodeId] = Temp.AvailableSupply;
            }
        
        }
        public RGraphSD(int nNumberOfSupply, int nNumberOfDemmand):base(nNumberOfDemmand+nNumberOfSupply) {

            mNumberDemmand = nNumberOfDemmand;
            mNumberSupply = nNumberOfSupply;
            mWeights = new int[mNumberOfVertices];

        }

        bool AreNeighbors(Kord A, Kord B, int NumNeighbors)
        {
            int x = Math.Abs(A.mX - B.mX);
            int y = Math.Abs(A.mY - B.mY);


            if(((x <=1) && (y<=1))||((x==1) && (y==2))||((x==2) && (y==1)))
                 return true;
            return false;
        }

        Kord GetNeighborVector(int Neighbor) { 

            Kord Result = new Kord();


            switch(Neighbor){
                case 0:
                        Result.mX = 1;
                        Result.mY = 0;
                    break;
                case 1:
                        Result.mX = -1;
                        Result.mY = 0;
                    break;
                case 2:
                        Result.mX = 0;
                        Result.mY = 1;
                    break;
                case 3:
                        Result.mX = 0;
                        Result.mY = -1;
                    break;
                case 4:
                        Result.mX = 1;
                        Result.mY = 1;
                    break;
                case 5:
                        Result.mX = -1;
                        Result.mY = 1;
                    break;
                case 6:
                        Result.mX = -1;
                        Result.mY = -1;
                    break;
                case 7:
                        Result.mX = 1;
                        Result.mY = -1;
                    break;
                case 8:
                        Result.mX = 1;
                        Result.mY = 2;
                    break;
               case 9:
                        Result.mX = -1;
                        Result.mY = 2;
                    break;
               case 10:
                        Result.mX = 1;
                        Result.mY = -2;
                    break;
               case 11:
                        Result.mX = -1;
                        Result.mY = -2;
                    break;
               case 12:
                        Result.mX = 2;
                        Result.mY = 1;
                    break;
               case 13:
                        Result.mX = -2;
                        Result.mY = 1;
                    break;
                case 14:
                        Result.mX = -2;
                        Result.mY = 1;
                    break;
                case 15:
                        Result.mX = -2;
                        Result.mY = -1;
                    break;
            
            
            }

            return Result;
        
                
            
        }
        public void RemoveAllSupplyConnections() {
            for (int i = 0; i < NumberOfVertices; i++)
                if(mWeights[i]>0)
                             RemoveConnections(i);
        
        }
        public int NumberSupply{
            get{return mNumberSupply;}
            set { mNumberSupply = value; }
        }
        public int NumberDemmand
        {
            get { return mNumberDemmand; }
            set { mNumberDemmand = value; }
        }



        public void GenrateRandomNegativeWeights(int Min, int nMax) {

            for (int i = 0; i < NumberOfVertices; i++)
            {
                mWeights[i] = -(Min + mGenerator.Next(nMax));
            }

        
        }
        public void GenerateRandomWeights() {

        
            int counter = 0;
            int rW, rI;


            GenrateRandomNegativeWeights(1, 4);
            while (counter < mNumberSupply) {

                rI = mGenerator.Next(NumberOfVertices);

                if (mWeights[rI] < 0) {

                    counter++;
                    rW = mGenerator.Next(10) + 4;
                    mWeights[rI] = rW;
                }


            
            }
        }
        public void GenerateRandomTreeEdges()
        {

            int a, b;
            int index; 
          
            int Height = (int)Math.Round(Math.Sqrt(NumberOfVertices));
            int Width = (int)Math.Round((NumberOfVertices / (float)Height) + 0.5);


            mNumberOfEdges = 0;
           
            List<Kord> Covered = new List<Kord>();
            List<Kord> Free = new List<Kord>();
          
            
            for (int i = 0; i < mNumberOfVertices; i++) {

                Free.Add(new Kord(i % Width, i / Width));
            }

            index = mGenerator.Next(Free.Count);

            Covered.Add(Free[index]);
            Free.RemoveAt(index);
            int k;
            int Choice;
            List<int>  Near = new List<int>();

            while (Free.Count > 0) {

                    index = mGenerator.Next(Covered.Count);
                    Near.Clear();
                    for (int j = 0; j < Free.Count; j++) {
                        if (AreNeighbors(Covered[index], Free[j], 16))
                            Near.Add(j);
                    }
                    if (Near.Count == 0)
                        Covered.RemoveAt(index);
                    else{
                            Choice = Near[mGenerator.Next(Near.Count)];
                            a = Covered[index].mX + Covered[index].mY * Width;
                            b = Free[Choice].mX + Free[Choice].mY * Width;
                            Covered.Add(Free[Choice]);
                            Free.RemoveAt(Choice);
                            AddEdge(a, b);
                            
                    }

                }


        }
            public void GenerateRandomEdges(int  nNumberOfEdges) {

                int a, b;
                int Neighbor;

                int Height = (int)Math.Round(Math.Sqrt(NumberOfVertices));
                int Width = (int)Math.Round((NumberOfVertices / (float)Height) +0.5);
          

                mNumberOfEdges  =0;
                Kord NVector;
                Kord PosA = new Kord();
                Kord PosB = new Kord();
                int offset;

                for (int i = 0; i < mNumberOfVertices-1; i++) {
                    AddEdge(i, i+1);
  
                
                }

                    while (mNumberOfEdges < nNumberOfEdges)
                    {

                        PosA.mX = mGenerator.Next(Width);
                        PosA.mY = mGenerator.Next(Height);

                        Neighbor = mGenerator.Next(8 + 8);
                        //      Neighbor = mGenerator.Next(8);
                        NVector = GetNeighborVector(Neighbor);

                        PosB.mX = PosA.mX + NVector.mX;
                        PosB.mY = PosA.mY + NVector.mY;

                        if ((PosA.mX >= 0) && (PosA.mX < Width) && (PosA.mY >= 0) && (PosA.mY < Height) &&
                            (PosB.mX >= 0) && (PosB.mX < Width) && (PosB.mY >= 0) && (PosB.mY < Height))
                        {

                            a = PosA.mX + PosA.mY * Width;
                            b = PosB.mX + PosB.mY * Width;


                            AddEdge(a, b);


                        }


                    }
        
        
        }
        public void Init() { 
            base.Init();
            mWeights = new int [mNumberOfVertices];
        }
        public int GetWeight(int i) { return mWeights[i]; }
        public int setWeight(int index, int weight) { return mWeights[index]=weight; }
       
        public int GetSupply(int i) { return mWeights[i]; }
        public int GetDemandSupply(int i) { return mWeights[i+mNumberSupply]; }

        public void Copy(RGraphSD A) {
            base.Copy(A);

            mNumberSupply = A.mNumberSupply;
            mNumberDemmand = A.mNumberDemmand;
        //    mNumberOfVertices = A.mNumberSupply + A.mNumberDemmand;
            mWeights = new int[mNumberOfVertices];

            for (int i = 0; i < mNumberOfVertices; i++) {
                mWeights[i] = A.mWeights[i];
            }
        }

        void AddEdge(int a, int b)
        {


            if ((b >= 0) && (b < NumberOfVertices) && (a >= 0) && (a < NumberOfVertices) )
            {

                if (!EdgeExists(a, b)) {

                    mEdges1[a].Add(b);
                    mEdges1[b].Add(a);
                    mNumberOfEdges++;

                }
//                mEdges1[a].Add(b);
 /*               if (mEdges[a, b] != true) { 
                     mEdges[a, b] = true;
                     mEdges[b, a] = true;
                     mNumberOfEdges++;
                }
  */
            }
        }
       
    }
}
