﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GraphSD
{
    public class RSubGraphNodeArray
    {

        RNodeSubgraph[] mSubgraphNodes;
        int             mSize;

        public RSubGraphNodeArray(RGraphSD iGraph)
        {

            mSize = iGraph.NumberOfVertices;

            mSubgraphNodes = new RNodeSubgraph[mSize];
            for (int i = 0; i < mSize; i++)
            {

                mSubgraphNodes[i] = new RNodeSubgraph(i);
                if (iGraph.GetWeight(i) > 0)
                    mSubgraphNodes[i].TreeConnect = int.MaxValue;

            }
        }
        public RNodeSubgraph this[int Index]{
        
                get{return mSubgraphNodes[Index]; }
               set { mSubgraphNodes[Index] = value; }
        
        }
        public bool IsNonLocated(int index) {

            return (mSubgraphNodes[index].SubGraphId == -1);
        }

        public List<int> GetNotInSubgraph() {

            List<int> Result = new List<int>();

            for (int i = 0; i < mSize; i++) {

                if (mSubgraphNodes[i].SubGraphId == -1)
                    Result.Add(i);
            }

            return Result;
        }

        public List<int> GetConnectedSubgraphs(int Id, RGraphSD iGraph)
        {

            List<int> Result = new List<int>();
            List<int> tNodes = new List<int>();

            tNodes = iGraph.GetConnections(Id);

            foreach (int con in tNodes) {

                if (mSubgraphNodes[con].SubGraphId != -1)
                    Result.Add(mSubgraphNodes[con].SubGraphId);
            
            }

            
            return Result;
        }

        public List<int> GetLeafs(int IdSubgraph, RPartitioningGraphSD iPartitioning) {

            List<int> Result = new List<int>();
            List<int> inside = new List<int>();


            inside = iPartitioning.GetSubGraph(IdSubgraph).GetInside();

            foreach (int el in inside) {
                if (mSubgraphNodes[el].TreeConnect == 0)
                    Result.Add(el);
            }

            return Result;
        }
    }
}
