﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GraphSD
{
    class RMove {

        int mNodeId;
        int mSourceId;
        int mDestId;


        public RMove(int nNodeId, int nSourceId, int nDestId) {

            mNodeId = nNodeId;
            mSourceId = nSourceId;
            mDestId = nDestId;
        }

        public int NodeId{
                get{ return mNodeId;}
                set{mNodeId = value;}
        }
        public int SourceId
        {
                get{ return mSourceId;}
                set{mSourceId = value;}
        }
        public int DestId
        {
                get{ return mDestId;}
                set{mDestId = value;}
        }

        public bool Equals(int nNodeId, int nSourceId, int nDestId)
        {
                    return ((mNodeId == nNodeId) &&  (mDestId == nDestId) && (mSourceId == nSourceId));
        }
        public bool Inverse(int nNodeId, int nSourceId, int nDestId)
        {
                    return ((mNodeId == nNodeId) &&  (mDestId == nSourceId) && (mSourceId == nDestId));
        }



        public bool Equals(RMove A)
        {
            return ((mNodeId == A.mNodeId) && (mDestId == A.mDestId) && (mSourceId == A.mSourceId));
        }
        public bool Inverse(RMove A)
        {
            return ((mNodeId == A.mNodeId) && (mDestId == A.mSourceId) && (mSourceId == A.mDestId));
        }
      
        
    }
    class RTabu
    {

        List<RMove> mTabuList;

        public RTabu() {
            mTabuList = new List<RMove>();
        }

        public void Empty()
        {
            mTabuList.Clear();
        }

        public void Add(int NodeId, int Source,int Dest)
        {
            mTabuList.Add(new RMove(NodeId, Source, Dest));
        }

        public bool Containst(int nNodeId, int nSource, int nDest){

            foreach (RMove Elem in mTabuList) {

                if (Elem.Equals(nNodeId, nSource, nDest))
                    return true;
            }
            return false;
        }

        public bool ContainstInverse(int nNodeId, int nSource, int nDest)
        {

            foreach (RMove Elem in mTabuList)
            {

                if (Elem.Inverse(nNodeId, nSource, nDest))
                    return true;
            }
            return false;
        }

        public bool IsLoop(int length){
        
              //  int[,]  Location = new int[length,2];
              //  int[,]  StartLocation = new int[length, 2];
                int[,] Location = new int[20, 2];
                int[,] StartLocation = new int[20, 2];
                  
            
            int MaxElem = Math.Min(mTabuList.Count-1, length);
                int TabuLength = mTabuList.Count;
                int NumDifferent = 0;
                bool contains;
                bool Result;
                int j;
                int Same = 0;

                for (int i = 1; i < MaxElem; i++) {
                    contains = false;
                    
                    for (j = 0; j < NumDifferent; j++)
                        if (Location[j, 0] == mTabuList[TabuLength - i].NodeId)
                        {
                            contains = true;
                            break;
                        }
                    if (!contains)
                    {
                        StartLocation[j, 0] = mTabuList[TabuLength - i].NodeId;
                        StartLocation[j, 1] = mTabuList[TabuLength - i].SourceId;

                        Location[j, 0] = mTabuList[TabuLength - i].NodeId;
                        Location[j, 1] = mTabuList[TabuLength - i].DestId;
                        NumDifferent++;
                    }
                    else {
                        Location[j, 0] = mTabuList[TabuLength - i].NodeId;
                        Location[j, 1] = mTabuList[TabuLength - i].DestId;
                    }

                    Same = 0;
                    for (int ik = 0; ik < NumDifferent; ik++)
                    {
                        if (Location[ik, 1] == StartLocation[ik, 1])
                            Same++;

                    }
                    if (Same == NumDifferent)
                        return true;
                }

                
                for (int i = 0; i < NumDifferent; i++) {
                    if (Location[i, 1] != StartLocation[i, 1])
                        return false;
                
                }
                    return true;
                 
        }
          public List<int> GetForbidden(int Subgraph) {

              int Steps  = mTabuList.Count-2;
              List<int>  Result = new List<int>();

              if(Steps <0)
                  return Result;

            //  for (int i = 0; i < Steps; i++)
//              { 

              if (IsLoop(10))
                  Result.Add(mTabuList[Steps].NodeId);


//                if(mTabuList[Steps].Inverse(mTabuList[Steps+1]))
//                    Result.Add(mTabuList[Steps].NodeId);
  //              }
    //          }

              return Result;
        }
        public bool InLastMoves(int iNodeId, int Moves){

            int MaxTest = Math.Min(Moves, mTabuList.Count);
            int NumTabu = mTabuList.Count;

            for(int i=1; i <= MaxTest; i++){
                if (mTabuList[NumTabu - i].NodeId == iNodeId)
                    return true;
            }

            return false;
        }

    }
}
