﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;




using System;
using System.IO;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;



namespace GraphSD
{

    public class Kord {
        public int mX;
        public int mY;

        public Kord(int nX, int nY) { mX = nX; mY = nY; }
        public Kord() { mX = 0; mY = 0; }
    
    }
    public class VisualiseGraphProblem
    {

        protected System.Drawing.Bitmap mBitmap;
        protected int mScreenX;
        protected int mScreenY;
        protected Graphics mScreen;
        protected int mCounter;
        protected int mFontSize;
        protected int mNodeSize;
        RGraphSD                mGraph;
        RPartitioningGraphSD    mPartitioning;

        Kord[]        mVertexPositions;

        public int NumberOfVertices {

            get { return mGraph.NumberOfVertices; }
        }

        public void SetGraph(RGraphSD   nGraph) {

            mGraph = nGraph;
            InitPositions();
            
                
        }

        public void SetPartitioning(RPartitioningGraphSD nPartitioning) {

            mPartitioning = nPartitioning;
        }
        Color GetColor(int Index) { 
        
            switch (Index){
                case 0:
                    return Color.Red;
                case 1:
                     return Color.Blue;
                case 2:
                     return Color.Green;
                case 3:
                     return Color.Turquoise;
                case 4:
                     return Color.Aqua;
                case 5:
                     return Color.Coral;
                case 6:
                     return Color.CornflowerBlue;
                case 7:
                     return Color.Tomato;
                case 8:
                     return Color.Cyan;
                case 9:
                     return Color.DeepPink;
                case 10:
                     return Color.ForestGreen;
                case 11:
                     return Color.IndianRed;
                case 12:
                     return Color.Lavender;
                case 13:
                     return Color.LightBlue;
                case 14:
                     return Color.LightPink;
                case 15:
                     return Color.Lime;
                case 16:
                     return Color.Maroon;
                case 17:
                     return Color.Magenta;
                case 18:
                     return Color.Magenta;
                case 19:
                     return Color.MediumVioletRed;
                case 20:
                     return Color.Purple;
               
                
            }

            return Color.Black;
        }

        public void InitPositions() {
            mVertexPositions = new Kord[NumberOfVertices];

            for (int i = 0; i < NumberOfVertices; i++)
                mVertexPositions[i] = new Kord();

        }

        public void GeneratePositions() {

            int Height = (int)Math.Round(Math.Sqrt(NumberOfVertices));
            int Width = (int)Math.Round((NumberOfVertices / (float)Height) +0.5);
            int counter = 0;

            int StepX = mScreenX / Width;
            int StepY = mScreenY / Height;


           


            for (int i = 0; i < Height; i++) { 
                    for (int j = 0; j < Width; j++) {
                        if(counter == NumberOfVertices)
                            break;

                        mVertexPositions[counter].mY = i * StepY + StepY /2;
                        mVertexPositions[counter].mX = j * StepX + StepX/2;

                        counter++;

                     }  
                if (counter == NumberOfVertices)
                break;
            }
        }

         public VisualiseGraphProblem() {

            mBitmap  = null;
            mScreenX = 0;
            mScreenY = 0;

            mFontSize = 16;
            mCounter = 0;
        }
         public VisualiseGraphProblem(int SizeX, int SizeY)
        {

            
            mScreenX = SizeX;
            mScreenY = SizeY;
            mBitmap = new Bitmap(mScreenX, mScreenY);
            mFontSize = 16;
            mCounter = 0;

           
        }

         public void SetScreen(Graphics nScreen)
         {



             mScreenX = Convert.ToInt16(nScreen.VisibleClipBounds.Width);
             mScreenY = Convert.ToInt16(nScreen.VisibleClipBounds.Height);

       

             mBitmap = new Bitmap(mScreenX, mScreenY);
             mScreen = nScreen;
             InitPositions();
             GeneratePositions();

         }

         public void DrawTest()
         {

             System.Drawing.Graphics tGraphics = Graphics.FromImage(mBitmap);
/*
             tGraphics.Clear(Color.White);
             DrawContainerBay(tGraphics);
             mScreen.DrawImage(mBitmap, 0, 0);
             tGraphics.Dispose();
 * 
*/

         
             tGraphics.Clear(Color.White);
             DrawEdges(tGraphics);
             DrawPartitioningEdges(tGraphics);
            
             DrawNodes(tGraphics);
             DrawPartitioning(tGraphics);
             mScreen.DrawImage(mBitmap, 0, 0);
             tGraphics.Dispose();


         }

         public void SaveImageOfGraph(string FileName)
         {

             System.Drawing.Graphics tGraphics = Graphics.FromImage(mBitmap);
           //  CaluclateSteps();
             tGraphics.Clear(Color.White);
             DrawGraph(tGraphics);
             mBitmap.Save(FileName);
             // mScreen.DrawImage(mBitmap, 0, 0);
             tGraphics.Dispose();


         }

         public void DrawNode(int i, Color mColor, System.Drawing.Graphics tGraphics) {


             Font drawFont = new Font("Arial", mFontSize);
             SolidBrush drawBrush = new SolidBrush(Color.White);
             SolidBrush fontBrush = new SolidBrush(Color.Black);
             string s;
             mNodeSize = 50;
             SizeF stringSize;
             SolidBrush nodeBrush = new SolidBrush(mColor);
             Pen nodePen = new Pen(nodeBrush, 3);


             s = Convert.ToString(mGraph.GetWeight(i));
             stringSize = tGraphics.MeasureString(s, drawFont);

             tGraphics.FillRectangle(drawBrush, new Rectangle(mVertexPositions[i].mX, mVertexPositions[i].mY, mNodeSize, mNodeSize));
             tGraphics.DrawRectangle(nodePen, new Rectangle(mVertexPositions[i].mX, mVertexPositions[i].mY, mNodeSize, mNodeSize));
             tGraphics.DrawString(s, drawFont, fontBrush, mVertexPositions[i].mX, mVertexPositions[i].mY);
         
         
         }

         public void DrawNodes(System.Drawing.Graphics tGraphics)
         {



             for (int i = 0; i < NumberOfVertices; i++) 
                        DrawNode(i, Color.Black, tGraphics);                   
             
         }


         public void DrawPartitioningEdges(System.Drawing.Graphics tGraphics) {

             RSubGraphSD TempSubGraph;
             List<int> Inside;
             for (int i = 0; i < mGraph.NumberSupply; i++) {

                 TempSubGraph = mPartitioning.GetSubGraph(i);
                 if (TempSubGraph != null)
                 {
                     Inside = TempSubGraph.GetInside();

                     foreach (int Elem in Inside)
                     {

                         for (int j = 0; j < mGraph.NumberOfVertices; j++)
                         {
                             if (mGraph.EdgeExists(Elem, j))
                             {

                                 DrawEdge(Elem, j, GetColor(i), tGraphics);
                             }

                         }
                     }
                 }    
             }
             /*

                 for (int i = 0; i < NumberOfVertices; i++)
                     for (int j = i + 1; j < NumberOfVertices; j++)
                     {

                         if (mPartitioning.GetGraph().EdgeExists(i, j))
                         {
                             //                          if (mGraph.EdgeExists(i, j)) {

                             DrawEdge(i, j, Color.Black, tGraphics);
                         }
                     }
 */
         
         }
         public void DrawPartitioning(System.Drawing.Graphics tGraphics){ 

             List<int>     Inside;
             Color         cColor;

             Font drawFont = new Font("Arial", mFontSize);
             SolidBrush drawBrush = new SolidBrush(Color.White);
             SolidBrush fontBrush = new SolidBrush(Color.Black);
             string s;
             mNodeSize = 50;
             SizeF stringSize;
             SolidBrush nodeBrush = new SolidBrush(Color.Black);
             Pen nodePen = new Pen(nodeBrush, 3);
             RSubGraphSD TempSubGraph;
             int Supply;

             for (int i = 0; i < mGraph.NumberSupply; i++)
             {

                 cColor = GetColor(i);

                 TempSubGraph = mPartitioning.GetSubGraph(i);

                 if (TempSubGraph != null)
                 {
                     Inside = TempSubGraph.GetInside();

                     foreach (int node in Inside)
                     {
                         DrawNode(node, cColor, tGraphics);
                     }
                     Supply = mPartitioning.GetSubGraph(i).SupplyNodeId;

                     s = Convert.ToString(mPartitioning.GetSubGraph(i).AvailableSupply);
                     s = Convert.ToString(mPartitioning.GetSubGraph(i).GetCoveredDemand());

                     stringSize = tGraphics.MeasureString(s, drawFont);
                     tGraphics.DrawString(s, drawFont, fontBrush, mVertexPositions[Supply].mX, mVertexPositions[Supply].mY + mNodeSize / 2);


                 }
             }

        
         }


         public void DrawEdge(int i, int j, Color ccolor, System.Drawing.Graphics tGraphics) {



             SolidBrush nodeBrush = new SolidBrush(ccolor);
             Pen nodePen = new Pen(nodeBrush, 3);

             tGraphics.DrawLine(nodePen, mVertexPositions[i].mX + mNodeSize / 2, mVertexPositions[i].mY + mNodeSize / 2,
                                                 mVertexPositions[j].mX + mNodeSize / 2, mVertexPositions[j].mY + mNodeSize / 2);
                     

         }
         public void DrawEdges(System.Drawing.Graphics tGraphics)
         {


             Font drawFont = new Font("Arial", mFontSize);
             SolidBrush drawBrush = new SolidBrush(Color.Black);
             SolidBrush currentBrush = new SolidBrush(Color.BlueViolet);


             SolidBrush nodeBrush = new SolidBrush(Color.Black);
             Pen nodePen = new Pen(nodeBrush, 3);

             
             string s;
             mNodeSize = 50;


             SizeF stringSize;

             for (int i = 0; i < NumberOfVertices; i++)
                 for (int j = i+1; j < NumberOfVertices; j++)
                     if (mGraph.EdgeExists(i, j)) {

                         DrawEdge(i, j, Color.LightGray, tGraphics);
                     /*    tGraphics.DrawLine(nodePen, mVertexPositions[i].mX + mNodeSize / 2, mVertexPositions[i].mY + mNodeSize / 2,
                                                     mVertexPositions[j].mX + mNodeSize / 2, mVertexPositions[j].mY + mNodeSize / 2);
                      * */
                     }
             
             nodePen.Brush = currentBrush;

             drawBrush.Dispose();
             drawFont.Dispose();
             nodePen.Dispose();
             nodeBrush.Dispose();



         }

         public virtual void DrawGraph(System.Drawing.Graphics tGraphics)
         {




             Font drawFont = new Font("Arial", mFontSize);
             SolidBrush drawBrush = new SolidBrush(Color.Black);
             SolidBrush currentBrush = new SolidBrush(Color.BlueViolet);



             SolidBrush boxBrush = new SolidBrush(Color.Black);
             Pen boxPen = new Pen(boxBrush, 3);

             SolidBrush BlockingBrush = new SolidBrush(Color.Red);
             SolidBrush NonBlocikngBrush = new SolidBrush(Color.Black);

             boxPen.Brush = currentBrush;

             drawBrush.Dispose();
             drawFont.Dispose();
             boxPen.Dispose();
             boxBrush.Dispose();


         }



         public virtual void SaveImageToArray(string Name, int special)
        {
               
                string FileName;
                mCounter++;
                FileName = Name + Convert.ToString(mCounter) + ".jpg";
                SaveImageOfGraph(FileName);
            

        }
    }
}
