﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GraphSD;
namespace TestGraphSD
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestFile()
        {
            RGraphSD SaveGralph = new RGraphSD(4, 14);
            RGraphSD LoadGraph = new RGraphSD();

            Random nGenerator = new Random(1);

            SaveGralph.SetGenerator(nGenerator);
            SaveGralph.GenerateRandomEdges(40);
            SaveGralph.GenerateRandomWeights();

            SaveGralph.SaveGraph("test.sgr");
            LoadGraph.LoadGraph("test.sgr");

            LoadGraph.SaveGraph("test1.sgr");
             
        }



        [TestMethod]
        public void TestGenerateTestFiles()
        {




            GraphPartitioningSolvedProblemSD Solution;
            Solution = GraphPartitioningProblemSD.GenerateSolvedGraph(3, 8, 21,1, 8, (float)0.9, 1, true);

            Solution.mGraph.SaveGraph("Opt.grf");
            Solution.mPartitioning.Save("Solution.sol");

        }

         [TestMethod]
               public void TestGenerateSetOfTest()
        {

             int nNumSupply=25;
             int nNumDemmand = 75;
             int nNumEdges= (nNumSupply+nNumDemmand)*2;
             int nMaxWeight =18;
             int nMinWeight = 10;

             float nCovered = (float)0.95;
             int nRandomSeed =1;

             GraphPartitioningProblemSD.GenerateTestsSet(nNumSupply, nNumDemmand, nNumEdges, nMinWeight, nMaxWeight, nCovered, false);
            
        }

        [TestMethod]
           public void TestGenerateAllTests()
         {

             int[] aNumSupply = new int[8];
             int[] aDemandMult = new int[4];
             int nNumSupply;
             int nNumDemmand;
            
             int nNumEdges ;
             int nMaxWeight = 30;
             int nMinWeight = 10;

            float nCovered = (float)0.95;
             double density = 2;
       //      int nRandomSeed = 1;

             int index = 0;


             index = 0;
             aNumSupply[index++] = 2;
             aNumSupply[index++] = 5;
             aNumSupply[index++] = 10;
             aNumSupply[index++] = 25;
             aNumSupply[index++] = 50;
             aNumSupply[index++] = 100;
             aNumSupply[index++] = 200;
             aNumSupply[index++] = 400;

             index = 0;
             aDemandMult[index++] = 3;
             aDemandMult[index++] = 5;
             aDemandMult[index++] = 10;
             aDemandMult[index++] = 20;
        
            
            for (int i = 0; i < 8; i++ )
                 for (int j = 0; j < 4; j++) {

                     nNumSupply = aNumSupply[i];
                     nNumDemmand = nNumSupply * aDemandMult[j];
                     nNumEdges = (int)(Math.Round((double)nNumSupply + nNumDemmand * density));

                     GraphPartitioningProblemSD.GenerateTestsSet(nNumSupply, nNumDemmand, nNumEdges, nMinWeight, nMaxWeight, nCovered, true);
                     GraphPartitioningProblemSD.GenerateTestsSet(nNumSupply, nNumDemmand, nNumEdges, nMinWeight, nMaxWeight, nCovered, false);
                 }

         }


       


    }
}
